
onmessage = function(evt) {
  var profileGeneral = [];
  var equidistance = 20.0;
  var min = 8848;
  var max = 0;
  var getHeight = function(p) {
    // get elevation data from array
    var pos = ((parseInt(p[1])*evt.data.width) + parseInt(p[0]));
    return evt.data.alpha[pos] * equidistance;
  };
  var p1 = [Math.round(Math.random()*(evt.data.width-1)), Math.round(Math.random()*(evt.data.height-1))];
  for (var i=1; i<evt.data.parts; i++) {
    var p2 = [Math.round(Math.random()*(evt.data.width-1)), Math.round(Math.random()*(evt.data.height-1))];
    // if (evt.data.useWorker) { postMessage({task:'line', id: evt.data.id, p1: p1, p2: p2}); }
    var len = Math.sqrt((Math.pow(p2[0]-p1[0],2)+Math.pow(p2[1]-p1[1],2)));
    var profile = [];
    for (var j=0; j<len-1; j++) {
      var ratio = (j+1) / (len-1-j);
      var x = parseInt((p1[0] + (ratio*p2[0])) / (1+ratio));
      var y = parseInt((p1[1] + (ratio*p2[1])) / (1+ratio));
      var h = getHeight([x,y]);
      if (h < min) { 
        min = h; 
        if (evt.data.useWorker) {
          postMessage({task:'newMin', min:min, id: evt.data.id}); 
        } 
      }
      if (h > max) { max = h; if (evt.data.useWorker) { postMessage({task:'newMax', max:max, id: evt.data.id}); } }
      profile.push(h);
      p1 = p2;
    }
    // "generalize" line segments:
    var pts = Math.floor(profile.length/10);
    for (var k=0; k<pts; k++) {
      var mean = 0;
      for (var l=k*10; l<k*10+10; l++) {
        mean += profile[l];
      }
      profileGeneral.push(mean/10);
    }

    if (evt.data.useWorker) {
      postMessage({task:'update', status: i, id: evt.data.id});
    }
  }

  var d = {
    id : evt.data.id,
    task: 'result',
    points: profileGeneral.length,
    // profile: p,
    min: min,
    max: max
  };
  if (evt.data.useWorker) {
    postMessage(d);
  }
  else {
    return {data:d};
  }
}
